#include <iostream>
#include <vector>
#include <cmath>
#include <fstream>

using namespace std;

#define xx first
#define yy second

typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pld;

pld vadd(pld v1, pld v2) {
    return {v1.xx + v2.xx, v1.yy + v2.yy};
}

pld vsub(pld v1, pld v2) {
    return {v1.xx - v2.xx, v1.yy - v2.yy};
}

pld vmul(pld v1, ld val) {
    return {v1.xx * val, v1.yy * val};
}

ld vvmul(pld v1, pld v2) {
    return v1.xx * v2.yy - v1.yy * v2.xx;
}

pair<pld, pld> calcDirPoint(pii start, pii dir1, pii dir2) {
    ld res1, res2;
    cout << '?' << ' ' << start.xx << ' ' << start.yy << ' ' << dir1.xx << ' ' << dir1.yy << endl;
    cin >> res1;
    cout << '?' << ' ' << start.xx << ' ' << start.yy << ' ' << dir2.xx << ' ' << dir2.yy << endl;
    cin >> res2;
    
    ld val = res2 / res1;
    pld v2 = vmul(dir2, val);
    pld dir = vadd(dir1, v2);

    // ofstream out("aaa.txt", ios::app);
    // out << fixed << setprecision(15);
    // out << res1 << endl;
    // out << res2 << endl;
    // out << "val: " << val << endl;
    // out << "dir1: " << dir1.xx << ' ' << dir1.yy << endl;
    // out << "v2: " << v2.xx << ' ' << v2.yy << endl;
    // out << "dir: " << dir.xx << ' ' << dir.yy << endl;

    return {start, dir};
}

pld raysIntersection(pair<pld, pld> ray1, pair<pld, pld> ray2) {
    pld ab = vsub(ray2.first, ray1.first);
    ld num = vvmul(ab, ray2.second);
    ld denum = vvmul(ray1.second, ray2.second);
    ld t = num / denum;
    pld dir = vmul(ray1.second, t);
    pld res = vadd(ray1.first, dir);

    // ofstream out("aaa.txt", ios::app);
    // out << fixed << setprecision(15);
    // out << "rays" << endl;
    // out << ab.xx << ' ' << ab.yy << endl;
    // out << "num: " << ' ' << num << endl;
    // out << "denum: " << ' ' << denum << endl;
    // out << "t: " << t << endl;
    // out << dir.xx << ' ' << dir.yy << endl;
    // out << "-----------------" << endl;
    // out << endl;

    return res;
}

int main() {
    pii p1 = {-1200, -1200};
    pair<pld, pld> ray1 = calcDirPoint(p1, {1, 0}, {0, 1});

    pii p2 = {1200, -1200};
    pair<pld, pld> ray2 = calcDirPoint(p2, {-1, 0}, {0, 1});

    pld res = raysIntersection(ray1, ray2);
    long long x = llround(res.xx);
    long long y = llround(res.yy);
    cout << "? " << x << " " << y << " 1 1" << endl;

    return 0;
}
