/**
 * Problem: morse
 * Correct solution (must be OK)
 * Author: romchela
 * DP adding word per step.
 * Time: O(L D)
 * Memory: O(L)
 */

#include <iostream>
#include <cstdio>
#include <climits>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define sz(x) (int)x.size()

vector<string> M = {
    /*A*/   "*-",
    /*B*/   "-***",
    /*C*/   "-*-*",
    /*D*/   "-**",
    /*E*/   "*",
    /*F*/   "**-*",
    /*G*/   "--*",
    /*H*/   "****",
    /*I*/   "**",
    /*J*/   "*---",
    /*K*/   "-*-",
    /*L*/   "*-**",
    /*M*/   "--",
    /*N*/   "-*",
    /*O*/   "---",
    /*P*/   "*--*",
    /*Q*/   "--*-",
    /*R*/   "*-*",
    /*S*/   "***",
    /*T*/   "-",
    /*U*/   "**-",
    /*V*/   "***-",
    /*W*/   "*--",
    /*X*/   "-**-",
    /*Y*/   "-*--",
    /*Z*/   "--**"
};

/*

+-+-+-+(H) ---() +(E) --- +-+++-+-+(L) ---()
+-+++-+-+(L) ---() +++-+++-+++(O) -----( )
+-+++-+++(W) --- +++-+++-+++---
+-+++-+---+-+++-+-+---+++-+-+


*/


int main() {
    int m, n;
    scanf("%d%d", &m, &n);
    getchar();
    
    vector<string> dict(m);
    for (int i = 0; i < m; i++) {
    	getline(cin, dict[i]);
    }
    
    sort(dict.begin(), dict.end());
    for (int i = 0; i < sz(dict); i++) {
    	reverse(dict[i].begin(), dict[i].end());
    }
    for (int i = 0; i < sz(M); i++) {
    	reverse(M[i].begin(), M[i].end());
    }
    
    string ss;
    string s = " ";
    while (getline(cin, ss)) {
    	s += ss;
    }

    vector<int> dp(sz(s), INT_MAX);
    vector<int> parent(sz(s), -1);
    vector<int> word(sz(s), -1);
    dp[sz(s) - 1] = 0;
    for (int i = sz(s) - 1; i > 0; i--) {
    	if (dp[i] == INT_MAX)
    		continue;
    	// printf("i = %d\n", i);
    	int pos = i;
    	for (int j = 0; j < sz(dict); j++) {
    		int errors = 0;
			int t = pos;
    		for (int k = 0; k < sz(dict[j]); k++) {
    			string & code = M[dict[j][k] - 'A'];
    			// printf("character is %c\n", dict[j][k]);
    			for (int q = 0; q < sz(code); q++) {
    				char c = code[q];
	    			if (c == '*') {
	    				int cur = pos;
	    				// printf("cur = %d\n", cur);
	    				while (pos > 0 && s[pos] == '+' && cur - pos <= 2)
	    					pos--;
	    				// printf("pos = %d\n", pos);					
	
	    				if (cur - pos == 3 || cur - pos == 0) {
	    					errors = INT_MAX;
	    					break;
	    				}
	    				errors += abs(cur - pos - 1);
	    				// printf("errors = %d\n", errors);
	    			} else {
	    				int cur = pos;
	    				// printf("cur = %d\n", cur);
	    				while (pos > 0 && s[pos] == '+' && cur - pos <= 4)
	    					pos--;
	    				// printf("pos = %d\n", pos);					

	    				if (cur - pos == 5 || cur - pos == 1) {
	    					errors = INT_MAX;
	    					break;
	    				}
	    				errors += abs(cur - pos - 3);
	    				// printf("errors = %d\n", errors);
	    			}
					if (pos > 0 && s[pos] != '-') {
    					errors = INT_MAX;
    					break;
    				}
    				if (pos != 0) {
		    			pos--;
		    		}
		    		
		    		if (pos > 0 && s[pos] == '-' && q != sz(code) - 1) {
	    				pos--;
	    				if (errors != INT_MAX)
		    				errors++;
	    				if (pos > 0 && s[pos] == '-') {
	    					errors = INT_MAX;
	    					break;
	    				}
	    			}
    			}
    			// printf("-------\n");
	    		if (pos > 0 && errors != INT_MAX) {
	    			int cur = pos;
	    			// printf("cur = %d\n", cur);
	    			int cnt = (k == sz(dict[j]) - 1) ? 4 : 2;
					while (pos > 0 && s[pos] == '-' && cur - pos <= cnt + 1)
						pos--;
					// printf("pos = %d\n", pos);	
					if (cur - pos == cnt + 2 || cur - pos == 0 || cur - pos < cnt - 1) {
						errors = INT_MAX;
						break;
					}
					errors += abs(cur - pos - cnt);
    				// printf("errors = %d\n", errors);
				}
				
				// printf("!!!!!!!!!!!!!!!\n");
				if (errors == INT_MAX)
					break;
    		}

    		// printf("overall errors = %d\n", errors);
			// printf("%d\n", dp[pos]);
			if (errors != INT_MAX && (dp[pos] > dp[i] + errors || 
				(dp[pos] == dp[i] + errors && word[pos] > j))) {
				dp[pos] = dp[i] + errors;
				parent[pos] = i;
				word[pos] = j;
				// printf("%d\n", dp[pos]);
			}
			
			pos = t;
    	}
    }

	for (int i = 0; i < sz(dict); i++) {
    	reverse(dict[i].begin(), dict[i].end());
    }
    printf("%d\n", (dp[0] == INT_MAX) ? -1 : dp[0]);
    if (dp[0] != INT_MAX) {
    	int cur = 0;
    	string res = "";
    	while (parent[cur] != -1) {
    		res += dict[word[cur]] + " ";
    		cur = parent[cur];
    	}
    	printf("%s\n", res.c_str());
    }

    return 0;
}
