/**
 * Problem: scheduler
 * Correct solution (must be OK)
 * Author: stgatilov
 * Uses std::set to find best-priority process
 * Time: O(T log N)
 */

//#pragma comment(linker, "/STACK:20000000")
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>
#include <cstdint>
#include <unordered_set>
#include <cinttypes>
#include <array>
#include <memory>

using namespace std;
typedef long long int64;
#ifdef HOME
    #define E(c) cerr<<#c
    #define Eo(x) cerr<<#x<<" = "<<(x)<<endl
    #define Ef(...) fprintf(stderr, __VA_ARGS__)
#else
    #define E(c) ((void)0)
    #define Eo(x) ((void)0)
    #define Ef(...) ((void)0)
#endif

const int MAXN = 100<<10;

typedef pair<int, int> Process;

int n, t;
int prior[MAXN];
set<Process> heap;
int cnt[MAXN];

int main(int argc, char **argv) {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d%d", &n, &t);
    for (int i = 0; i < n; i++)
        scanf("%d", &prior[i]);

    for (int i = 0; i < n; i++)
        heap.insert(make_pair(-prior[i], i));

    for (int i = 0; i < t; i++) {
        Process maxTag = *heap.begin();
        int idx = maxTag.second;
        //assert(idx >= 0 && idx < n);
        cnt[idx]++;

        heap.erase(heap.begin());
        int newValue = prior[idx] - (i+1);
        maxTag.first = -newValue;
        heap.insert(maxTag);
    }

    for (int i = 0; i < n; i++)
        printf("%d ", cnt[i]);

    return 0;
}
