/**
 * Problem: dnd
 * Correct solution
 * Author: romchela
 *
 * Solution: dp[k][score] - probability to achieve 'score' in k cubes.
 */
#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

int main() {
	int T;
	scanf("%d", &T);
	
	vector<vector<double>> dp(11, vector<double>(11 * 21, 0.0));
	for (int i = 0; i < T; i++) {
		int w, d;
		scanf("%d%d", &w, &d);
		double ans = 0.0;
		for (int j = 0; j < w; j++) {
			int n, f, m;
			scanf("%d%d%d", &n, &f, &m);
			int max_score = n * f;
			if (d - m > max_score) continue;
			dp.assign(11, vector<double>(11 * 21, 0.0));
			for (int cube_num = 1; cube_num <= f; cube_num++) {
				dp[0][cube_num] = 1.0 / f;
			}
			for (int k = 1; k < n; k++) {
				for (int score = 1; score <= max_score; score++) {
					for (int cube_num = 1; cube_num <= f; cube_num++) {
						if (score - cube_num >= 0) {
							dp[k][score] += dp[k - 1][score - cube_num] * (1.0 / f);
						}
					}
				}
			}
			
			double cur_ans = 0.0;
			for (int score = max(d - m, 0); score <= max_score; score++) {
				cur_ans += dp[n - 1][score];
			}
			ans = max(ans, cur_ans);
		}
		printf("%.12lf\n", ans);
	}
	
	return 0;
}